/*

logoff.scr -- automatic logoff screensaver, version 1.0

Copyright (C) Digital Advantage Corp., 2003

URL: http://www.atmarkit.co.jp/fwin2k/win2ktips/283f_logoff/f_logoff.html

*/

#include <windows.h>

#define BUTTON_OK     0
#define BUTTON_CANCEL 1
#define TITLE TEXT("LogOff Saver")

void LogOff(void);

LRESULT CALLBACK WndProc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp) {
	static DWORD TimeLimit;
	static TCHAR Caption[32];
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rctSize;
  DWORD RemainingTime;

	switch (msg) {
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wp)) {
		case BUTTON_OK:
	  	LogOff();
			break;
		case BUTTON_CANCEL:
		  PostQuitMessage(0);
			break;
		}
		return 0;
	case WM_CREATE:
		TimeLimit = GetTickCount() + 30000;
		SetTimer(hwnd , 1 , 500 , NULL);
		return 0;
	case WM_TIMER:
	  RemainingTime = (TimeLimit - GetTickCount()) / 1000;
	  if(RemainingTime <= 0){
	  	LogOff();
	  }else{
	  	wsprintf(Caption , "%d bɃOIt܂B", RemainingTime);
			InvalidateRect(hwnd , NULL , TRUE);
		}
		return 0;
	case WM_PAINT:
		hdc = BeginPaint(hwnd , &ps);
		GetClientRect(hwnd , &rctSize);
		DrawText(hdc , Caption , -1 , &rctSize , DT_CENTER);
		EndPaint(hwnd , &ps);
		return 0;
	}
	return DefWindowProc(hwnd , msg , wp , lp);
}

int WINAPI WinMain(HINSTANCE hInstance , HINSTANCE hPrevInstance ,
			PSTR lpCmdLine , int nCmdShow ) {
	HWND hwnd;
	MSG msg;
	WNDCLASS winc;

  int aboutbox = 1;
	if(__argc >= 2 && (__argv[1][0]=='-' || __argv[1][0]=='/')){
		if(__argv[1][1]=='S' || __argv[1][1]=='s'){
		  aboutbox = 0;
		}else if(__argv[1][1]=='P' || __argv[1][1]=='p'){
  	  return 0;
  	}
	}
	
	if(aboutbox){
	  MessageBox(NULL, TEXT("LogOff Saver\r\nCopyright (C) Digital Advantage 2003"),
	  	TITLE, 0);
	  return 0;
	}


	winc.style		= CS_HREDRAW | CS_VREDRAW;
	winc.lpfnWndProc	= WndProc;
	winc.cbClsExtra	= winc.cbWndExtra	= 0;
	winc.hInstance		= hInstance;
	winc.hIcon		= LoadIcon(NULL , IDI_APPLICATION);
	winc.hCursor		= LoadCursor(NULL , IDC_ARROW);
	winc.hbrBackground	= (HBRUSH)GetStockObject(WHITE_BRUSH);
	winc.lpszMenuName	= NULL;
	winc.lpszClassName	= TEXT("LOGOFF");

	if (!RegisterClass(&winc)) return -1;

	hwnd = CreateWindow(
			TEXT("LOGOFF") , TITLE ,
			DS_SYSMODAL | WS_VISIBLE ,
			GetSystemMetrics(SM_CXSCREEN) / 2 - 120,
			GetSystemMetrics(SM_CYSCREEN) / 2 -  50,
			240 , 100 ,
			NULL , NULL , hInstance , NULL
	);

	CreateWindow(
		TEXT("BUTTON") , TEXT("OIt") ,
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
		24 , 32 , 84, 20,
		hwnd , (HMENU)BUTTON_OK , hInstance , NULL
	);

	CreateWindow(
		TEXT("BUTTON") , TEXT("LZ") ,
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON ,
		120 , 32 , 84, 20,
		hwnd , (HMENU)BUTTON_CANCEL , hInstance , NULL
	);

	if (hwnd == NULL) return -1;

	while(GetMessage(&msg , NULL , 0 , 0)) DispatchMessage(&msg);
	return msg.wParam;
}

void LogOff(){
	PostQuitMessage(0);
  ExitWindowsEx(EWX_LOGOFF, 0);
}
